##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (LessTools)	= PkgName
# sampledir (ksm-lesstools)	= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (lesstools)	= config file name (no extension)
# sampledm (lesstoolsd)		= the daemon (rc-script, rc-link, systemd.service)
# sample (lesstools)		= all others
##############################################################################

# Specfile for LessTools

%define name		ksm-lesstools
%define version		0.0.1
%define release		0.0.0
%define _arch		noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _sysddir	/etc/systemd/system
%define _uxbindir	/usr/bin
%define _uxsbindir	/usr/sbin
%define _bindir		/usr/local/bin
%define _sbindir	/usr/local/sbin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	Programs to extent less
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Other
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	lesstoolspkg,lesstoolscapab
Requires:	less,zip,gzip,bzip2,xz
Requires:	ksm-lib-sh >= 3.0.3-1.0.0
#Requires:	ksm-lesstools = %{version}-%{release}	# if lang pkg
#Provides:	lesstoolsd
#Conflicts:	lesstoolsd-other,liblesstools == 0.0.0
#Obsoletes:	mylesstoolsd

%description
This package contains programs for to  extent the usability of less.
The package contains the following programs:

 lessopen.sh, lesspipe.sh

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/lesstools.conf
#%config %{_confdir}/lesstools.conf
#%config %{_scnfdir}/lesstools
#%attr(644,root,root)%{_confdir}/lesstools.conf
#%attr(644,root,root)%{_scnfdir}/lesstools

#%attr(744,root,root)%{_rcdir}/lesstoolsd
#%attr(777,root,root)%{_sbindir}/rclesstoolsd
#%attr(744,root,root)%{_sbindir}/lesstoolsd.sh

%attr(755,root,root)%{_bindir}/lessopen.sh
%attr(755,root,root)%{_bindir}/lesspipe.sh

%{_datadir}/RELEASE
%{_datadir}/VERSION
#%attr(744,root,root)%{_datadir}/lesstoolsd.rc
#%{_datadir}/lesstoolsd.service

#/usr/share/applications/lesstools.desktop

#%{_icondir}/16x16/apps/lesstools.png
#%{_icondir}/22x22/apps/lesstools.png
#%{_icondir}/32x32/apps/lesstools.png
#%{_icondir}/48x48/apps/lesstools.png
#%{_icondir}/64x64/apps/lesstools.png
#%{_icondir}/128x128/apps/lesstools.png
#%{_icondir}/256x256/apps/lesstools.png
#%{_icondir}/512x512/apps/lesstools.png
#/usr/share/pixmaps/lesstools.png

%docdir %{_man1dir}
%{_man1dir}/lessopen.sh.1.gz
%{_man1dir}/lesspipe.sh.1.gz

%docdir %{_man8dir}
#%{_man8dir}/lesstoolsd.sh.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
%{_docdir}/README.de

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

#ngroup='' nuser='' npwd='' ncomm='' nhomedir='' nlogsh='' ngid=0 nuid=0 ret=0

# backup config files
#test -e %{_confdir}/lesstools.conf && cp %{_confdir}/lesstools.conf %{_confdir}/lesstools.conf.rpmsave
#test -e %{_scnfdir}/lesstools && cp %{_scnfdir}/lesstools %{_scnfdir}/lesstools.rpmsave

# disable lesstools daemon and stop lesstoolsd
#test -x %{_bindir}/togglelesstools && %{_bindir}/togglelesstools -d -q > /dev/null 2>&1
#test -x %{_rcdir}/lesstoolsd && %{_rcdir}/lesstoolsd stop -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
#rm -f %{_libdir}/libfuncstd-sh

# uninstall desktop files
#xdg-desktop-menu uninstall \
#	/usr/share/applications/lesstools.directory \
#	/usr/share/applications/lesstools.desktop \
#	/usr/share/applications/lesstools-admin.desktop

# remove entries from file
#f=file
#t=/tmp/ksm-lesstools
#s=ksm-lesstools
#grep -q $s $f
#ret=$?
#if [ "$ret" -eq 0 ]; then
#	cat $f | grep -v $s > $t
#	cp $t $f
#	rm -f $t
#fi
#ret=0

# INIT SCRIPT/SYSTEMD UNIT - uninstall LessTools
#if [ -d %{_sysddir} ]; then				# systemd
#	if [ -e %{_sysddir}/lesstoolsd.service ]; then
#		systemctl stop lesstoolsd.service
#		systemctl disable lesstoolsd.service
#		rm %{_sysddir}/lesstoolsd.service
#		systemctl daemon-reload
#	fi
#else							# SysV init
#	test -x %{_rcdir}/lesstoolsd && %{_rcdir}/lesstoolsd stop > /dev/null 2>&1
#	insserv -r lesstoolsd > /dev/null 2>&1
#	rm -f %{_rcdir}/lesstoolsd
#	rm -f %{_sbindir}/rclesstoolsd
#fi

#if [ "$1" == 1 ]; then					# install package
#	# create group and user
#	ngroup=nobody					# new group account
#	ngid=65533					# new GID
#	nuser=nobody					# new user account
#	nuid=65534					# new UID
#	npwd=nobody					# password for new usr
#	ncomm="nobody"					# comment for new usr
#	nhomedir=/var/lib/$nuser			# home dir for new usr
#	nlogsh=/bin/bash			# login shell for new user
#	grep -m 1 "^$ngroup:" /etc/group > /dev/null 2>&1
#	ret=$?
#	if [ "$ret" -eq 1 ]; then			# group not found
#		groupadd --preferred-gid $ngid $ngroup
#	fi
#	grep -m 1 "^$nuser:" /etc/passwd > /dev/null 2>&1
#	ret=$?
#	if [ "$ret" -eq 1 ]; then			# user not found
#		useradd -c "$ncomm" -d $nhomedir -g $ngroup -m -p $npwd --preferred-uid $nuid -s $nlogsh $nuser
#	fi
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# set config pathname and all config vars from new config file
#cf=%{_confdir}/lesstools.conf
#cnfvars='MyVar1 MyVar2'

#c='' s='' t='' cnt=0 i=0 ret=0
#rcfile='' updcmd='' u='' usr=''

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

# enable lesstools daemon
#test -x %{_bindir}/togglelesstools && %{_bindir}/togglelesstools -e -q > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog
#ln -sf %{_libdir}/libfuncstd-sh-%{version} %{_libdir}/libfuncstd-sh

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/lesstools.directory \
#	/usr/share/applications/lesstools.desktop \
#	/usr/share/applications/lesstools-admin.desktop

# add entries to file
#f=file
#te=file.add
#cat %{_datadir}/$te >> $f

# INIT SCRIPT/SYSTEMD UNIT - install LessTools
#if [ -d %{_sysddir} ]; then				# systemd
#	cp --preserve=mode %{_datadir}/lesstoolsd.service %{_sysddir}/
#	systemctl daemon-reload
#	systemctl enable lesstoolsd.service
#	echo "lesstoolsd is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start lesstoolsd within yast or manual with:"
#	echo "systemctl start lesstoolsd.service"
#else							# SysV init
#	cp --preserve=mode %{_datadir}/lesstoolsd.rc %{_rcdir}/lesstoolsd
#	ln -sf %{_rcdir}/lesstoolsd %{_sbindir}/rclesstoolsd
#	insserv lesstoolsd > /dev/null 2>&1
#	echo "lesstoolsd is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start lesstoolsd within yast or manual with rclesstoolsd start"
#fi

#if [ "$1" == 1 ]; then					# install package
#	echo "Configure $cf"
#	echo "Users must create HOME/.lesstoolsrc with update-lesstools"
#else							# upgrade package
#	# update global conf
#	if [ -e $cf.rpmsave ]; then
#		#cp $cf $cf.rpmnew
#		. $cf
#		. $cf.rpmsave
#
#		# update conf vars START -------------------------------------
#		if [ -x %{_bindir}/replcnfvar ]; then
#			for c in $cnfvars; do
#				t="\$$c"
#				eval s="$t"
#				s=\"$s\"
#				%{_bindir}/replcnfvar $cf $c "$s"
#			done
#		else
#			echo "Error - cmd replcnfvar not found or not executable!" >&2
#			echo "Conf file not updated!" >&2
#		fi
#		# update conf vars STOP --------------------------------------
#
#		# update array vars START ------------------------------------
#		# array var MainArr
#		cnt=${#MainArr[@]}			# max index of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
#			while [ "$i" -lt $cnt ]; do
#				let i++
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi
#		# update array vars STOP -------------------------------------
#
#		# compare new conf vars <--> old conf vars
#		diff $cf $cf.rpmsave > /dev/null 2>&1
#		ret=$?
#		if [ "$ret" -eq 0 ]; then
#			rm $cf.rpmsave
#		else
#			echo "Check $cf"
#		fi
#	fi
#
#	# update all users conf START ----------------------------------------
#	rcfile='.lesstoolsrc'
#	updcmd="%{_bindir}/update-lesstools -q"
#	usr=`/usr/bin/grep /home/ /etc/passwd | /usr/bin/cut -d : -f 1`
#	for u in "$usr"; do
#		if [ -e /home/$u/$rcfile ]; then
#			/bin/su $u -c "$updcmd"
#		fi
#	done
#	if [ -e /root/$rcfile ]; then
#		$updcmd
#	fi
#	# update all users conf STOP -----------------------------------------
#
#	echo "If new version then users must update HOME/.lesstoolsrc with update-lesstools"
#fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

#if [ "$1" == 0 ]; then					# remove package
	# backup config files
	#test -e %{_confdir}/lesstools.conf && cp %{_confdir}/lesstools.conf %{_confdir}/lesstools.conf.rpmsave
	#test -e %{_scnfdir}/lesstools && cp %{_scnfdir}/lesstools %{_scnfdir}/lesstools.rpmsave

	# disable lesstools daemon and stop lesstoolsd
	#test -x %{_bindir}/togglelesstools && %{_bindir}/togglelesstools -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/lesstoolsd && %{_rcdir}/lesstoolsd stop -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	#rm -f %{_libdir}/libfuncstd-sh

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/lesstools.directory \
	#	/usr/share/applications/lesstools.desktop \
	#	/usr/share/applications/lesstools-admin.desktop

	# remove entries from file
	#f=file
	#t=/tmp/ksm-lesstools
	#s=ksm-lesstools
	#grep -q $s $f
	#ret=$?
	#if [ "$ret" -eq 0 ]; then
	#	cat $f | grep -v $s > $t
	#	cp $t $f
	#	rm -f $t
	#fi
	#ret=0

	# INIT SCRIPT/SYSTEMD UNIT - uninstall LessTools
	#if [ -d %{_sysddir} ]; then				# systemd
	#	if [ -e %{_sysddir}/lesstoolsd.service ]; then
	#		systemctl stop lesstoolsd.service
	#		systemctl disable lesstoolsd.service
	#		rm %{_sysddir}/lesstoolsd.service
	#		systemctl daemon-reload
	#	fi
	#else							# SysV init
	#	test -x %{_rcdir}/lesstoolsd && %{_rcdir}/lesstoolsd stop > /dev/null 2>&1
	#	insserv -r lesstoolsd > /dev/null 2>&1
	#	rm -f %{_rcdir}/lesstoolsd
	#	rm -f %{_sbindir}/rclesstoolsd
	#fi
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/ksm-lesstools
#else							# upgrade package
fi
exit 0

%changelog
* Tue May 05 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.0.0
- The package has been revised/improved.

* Tue May 05 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.0-0.0.0
- This is the 1. version.
- The package contains following commands
  all moved from package ksm-utils:
  lessopen.sh	Preprocessor for 'less'
  lesspipe.sh	Uncompress/process a file for 'less'
